routes/web.php
<?php

use App\Http\Controllers;
use Illuminate\Routing\Router;
use App\Http\Controllers\Settings;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\AnnouncementController;
use App\Http\Controllers\Student\PreSurveyController;
use App\Http\Controllers\Student\PostSurveyController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [Controllers\PortalController::class, 'index'])->name('portal.index');
Route::get('privacy-policy', [Controllers\PageController::class, 'indexPolicy'])->name('page.policy');
Route::get('disclaimer', [Controllers\PageController::class, 'indexDisclaimer'])->name('page.disclaimer');

Route::get('orientation-leader-activation/{remember_token}', [Controllers\Admin\UserController::class, 'orientationLeaderActivation'])->name('orientation-leader-activation');

Route::group(['prefix' => 'microsoft', 'as' => 'microsoft.'], function () {
    Route::get('login', [Controllers\Auth\Microsoft\LoginController::class, 'login'])->name('login');
    Route::get('login/callback', [Controllers\Auth\Microsoft\LoginController::class, 'callback'])->name('login.callback');
});

Auth::routes(['verify' => true]);

// Handle all user path
Route::group(['middleware' => ['auth', 'verified']], function () {
    Route::get('dashboard', [Controllers\DashboardController::class, 'index'])->name('dashboard.index');
    Route::get('profile', [Controllers\ProfileController::class, 'index'])->name('profile.index');
    Route::post('profile', [Controllers\ProfileController::class, 'store'])->name('profile.store');
    Route::get('profile/notification', [Controllers\ProfileController::class, 'indexNotification'])->name('profile.notification.index');
    Route::post('profile/notification/read/{read}', [Controllers\ProfileController::class, 'updateNotificationRead'])->name('profile.notification-read.update');
    Route::get('profile/password', [Controllers\ProfileController::class, 'indexPassword'])->name('profile.password.index');
    Route::post('profile/password', [Controllers\ProfileController::class, 'storePassword'])->name('profile.password.store');
    Route::post('google-accounts/share-event', [Controllers\GoogleAccountController::class, 'shareEvent'])->name('google-accounts.share-event');
    Route::post('google-accounts/share-events', [Controllers\GoogleAccountController::class, 'shareEvents'])->name('google-accounts.share-events');
    Route::get('orientations/export-timetable', [Controllers\OrientationController::class, 'exportTimetable'])->name('orientations.export-timetable');
    Route::get('timetables', [Controllers\OrientationController::class, 'index'])->name('orientations.index');
});

// Handle student path
Route::group(['middleware' => ['auth', 'verified', 'student']], function () {
    Route::get('resources', [Controllers\ResourceController::class, 'index'])->name('resources.index');
    Route::get('resources/{resource}', [Controllers\ResourceController::class, 'show'])->name('resources.show');
    Route::get('arrivals', [Controllers\ArrivalController::class, 'index'])->name('arrivals.index');
    Route::get('arrivals/{arrival}', [Controllers\ArrivalController::class, 'show'])->name('arrivals.show');
    // Route::get('pre-orientations', [Controllers\PreOrientationController::class, 'index'])->name('pre-orientations.index');

    Route::prefix('announcements')->group(function (Router $router) {
        $router->get('/', [AnnouncementController::class, 'index'])->name('announcement.index');
        $router->get('/{slug}', [AnnouncementController::class, 'show'])->name('announcement.show');
    });

    Route::put('timetables/attendance', [Controllers\OrientationController::class, 'upsertAttendance'])->name('orientations.upsert-attendance');
    Route::put('timetables/{orientation}/rate', [Controllers\OrientationController::class, 'updateRate'])->name('orientations.update-rate');
    Route::put('timetables/{orientation}/rsvp', [Controllers\OrientationController::class, 'upsertRsvp'])->name('orientations.upsert-rsvp');
    Route::put('timetables/{orientation}/rsvp-yes', [Controllers\OrientationController::class, 'upsertRsvpYes'])->name('orientations.upsert-rsvp-yes');
    Route::put('timetables/{orientation}/rsvp-no', [Controllers\OrientationController::class, 'upsertRsvpNo'])->name('orientations.upsert-rsvp-no');

    Route::get('orientations', [Controllers\OrientationController::class, 'index2'])->name('orientations.index2');
    Route::get('orientations/post-survey', [PostSurveyController::class, 'index'])->name('orientations.post-survey');
    Route::post('orientations/post-survey', [PostSurveyController::class, 'store']);

    Route::resource('club-societies', Controllers\ClubSocietyController::class);
    Route::resource('attendances', Controllers\AttendanceController::class);
    Route::resource('surveys', Controllers\SurveyController::class);
    Route::resource('faqs', Controllers\FaqController::class);

    Route::prefix('preorientations')->name('student.preorientation.')->group(function (Router $router) {
        $router->get('', [Controllers\Student\PreorientationController::class, 'index'])->name('index');
        $router->get('survey', [PreSurveyController::class, 'index'])->name('survey');
        $router->post('survey', [PreSurveyController::class, 'store']);
    });
});

// Handle admin path
Route::group(['prefix' => 'admin', 'as' => 'admin.', 'middleware' => ['auth', 'permission:admin', 'verified']], function () {
    Route::get('dashboard', [Controllers\DashboardController::class, 'indexAdmin'])->name('dashboard.index');
    Route::group(['prefix' => 'announcements', 'as' => 'announcements', 'middleware' => 'permission:manage_announcements'], function (Router $router) {
        $router->get('/', [Controllers\Admin\AnnouncementController::class, 'index'])->name('.index');
        $router->get('create', [Controllers\Admin\AnnouncementController::class, 'create'])->name('.create');
        $router->post('store', [Controllers\Admin\AnnouncementController::class, 'store'])->name('.store');
        $router->get('preview/{uuid}', [Controllers\Admin\AnnouncementController::class, 'show'])->name('.show');
        $router->get('edit/{uuid}', [Controllers\Admin\AnnouncementController::class, 'edit'])->name('.edit');
        $router->patch('update/{uuid}', [Controllers\Admin\AnnouncementController::class, 'update'])->name('.update');
        $router->delete('delete/{uuid}', [Controllers\Admin\AnnouncementController::class, 'destroy'])->name('.delete');
    });

    // Route::resource('attendances', Controllers\Admin\AttendanceController::class);
    Route::group(['middleware' => ['permission:manage_users']], function () {
        Route::post('users/bulk/role', [Controllers\Admin\UserController::class, 'updateBulkRole'])->name('users.update-bulk-role');
        Route::post('users/bulk/active', [Controllers\Admin\UserController::class, 'updateBulkActive'])->name('users.update-bulk-active');
        Route::post('users/bulk/inactive', [Controllers\Admin\UserController::class, 'updateBulkInactive'])->name('users.update-bulk-inactive');
        Route::post('users/admin', [Controllers\Admin\UserController::class, 'storeAdmin'])->name('users.store-admin');
        Route::put('users/{user}/active', [Controllers\Admin\UserController::class, 'updateActive'])->name('users.update-active');
        Route::resource('users', Controllers\Admin\UserController::class);
    });
    Route::group(['middleware' => ['permission:manage_roles']], function () {
        Route::post('roles/bulk/active', [Controllers\Admin\RoleController::class, 'updateBulkActive'])->name('roles.update-bulk-active');
        Route::post('roles/bulk/inactive', [Controllers\Admin\RoleController::class, 'updateBulkInactive'])->name('roles.update-bulk-inactive');
        Route::put('roles/{role}/active', [Controllers\Admin\RoleController::class, 'updateActive'])->name('roles.update-active');
        Route::resource('roles', Controllers\Admin\RoleController::class);
    });
    Route::resource('quizzes', Controllers\Admin\QuizController::class);
    Route::group(['middleware' => ['permission:manage_resources']], function () {
        Route::delete('resources/{resource}/file/{file}', [Controllers\Admin\ResourceController::class, 'destroyFile'])->name('resources.destroy-file');
        Route::delete('resources/{resource}/link/{link}', [Controllers\Admin\ResourceController::class, 'destroyLink'])->name('resources.destroy-link');
        Route::put('resources/{resource}/active', [Controllers\Admin\ResourceController::class, 'updateActive'])->name('resources.update-active');
        Route::put('resources/{resource}/file/{file}', [Controllers\Admin\ResourceController::class, 'updateFile'])->name('resources.update-file');
        Route::put('resources/{resource}/link/{link}', [Controllers\Admin\ResourceController::class, 'updateLink'])->name('resources.update-link');
        Route::post('arrivals/{arrival}/clone', [Controllers\Admin\ArrivalController::class, 'clone'])->name('arrivals.clone');
        Route::post('arrivals/bulk/active', [Controllers\Admin\ArrivalController::class, 'updateBulkActive'])->name('arrivals.update-bulk-active');
        Route::post('arrivals/bulk/inactive', [Controllers\Admin\ArrivalController::class, 'updateBulkInactive'])->name('arrivals.update-bulk-inactive');
        Route::resource('arrivals', Controllers\Admin\ArrivalController::class);
        Route::post('resources/bulk/active', [Controllers\Admin\ResourceController::class, 'updateBulkActive'])->name('resources.update-bulk-active');

app/Http/Controllers/Admin/OrientationController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Services\Admin\OrientationService;
use App\Traits\Controllers\BaseControllerTrait;
use Illuminate\Http\Request;

class OrientationController extends Controller
{
    use BaseControllerTrait;

    public function __construct()
    {
        $this->service = new OrientationService();
    }

    public function index2(Request $request)
    {
        return $this->service->index2($request, auth()->user());
    }

    public function calculateStudent(Request $request)
    {
        $results = $this->service->calculateStudent($request->all(), auth()->user());
        return $this->arrayResponse($results);
    }

    public function storeAttendance(Request $request, $uuid)
    {
        return $this->service->storeAttendance($request->all(), auth()->user(), $uuid);
    }

    public function storeRecording(Request $request, $uuid)
    {
        return $this->service->storeRecording($request->all(), auth()->user(), $uuid);
    }

    public function clone(Request $request, $uuid)
    {
        $results = $this->service->clone($request, auth()->user(), $uuid);
        return $this->arrayResponse($results);
    }

    public function updateLink(Request $request, $uuidOrientation, $uuidLink)
    {
        return $this->service->updateLink($request->all(), auth()->user(), $uuidOrientation, $uuidLink);
    }

    public function destroyAttendance(Request $request, $uuidOrientation, $uuidAttendance)
    {
        return $this->service->deleteAttendance($request->all(), auth()->user(), $uuidOrientation, $uuidAttendance);
    }

    public function destroyLink(Request $request, $uuidOrientation, $uuidLink)
    {
        return $this->service->deleteLink($request->all(), auth()->user(), $uuidOrientation, $uuidLink);
    }

    public function destroyFile(Request $request, $uuidOrientation, $uuidFile)
    {
        return $this->service->deleteFile($request->all(), auth()->user(), $uuidOrientation, $uuidFile);
    }

    public function destroyRecordingFile(Request $request, $uuidOrientation, $uuidFile)
    {
        return $this->service->deleteRecordingFile($request->all(), auth()->user(), $uuidOrientation, $uuidFile);
    }

    public function destroyRecordingLink(Request $request, $uuidOrientation, $uuidLink)
    {
        return $this->service->deleteRecordingLink($request->all(), auth()->user(), $uuidOrientation, $uuidLink);
    }
}

app/Http/Controllers/Admin/Setting/OrientationController.php
<?php

namespace App\Http\Controllers\Admin\Setting;

use App\Http\Controllers\Controller;
use App\Services\Admin\Setting\OrientationService;
use App\Traits\Controllers\BaseControllerTrait;

class OrientationController extends Controller
{
    use BaseControllerTrait;

    public function __construct()
    {
        $this->service = new OrientationService();
    }
}

app/Http/Controllers/OrientationController.php
<?php

namespace App\Http\Controllers;

use App\Services\OrientationService;
use App\Traits\Controllers\BaseControllerTrait;
use Illuminate\Http\Request;

class OrientationController extends Controller
{
    use BaseControllerTrait;

    public function __construct()
    {
        $this->service = new OrientationService();
    }

    public function index2(Request $request)
    {
        $this->service->debug($request, __METHOD__);
        return $this->service->index2($request, auth()->user());
    }

    public function exportTimetable(Request $request)
    {
        return $this->service->exportTimetable($request, auth()->user());
    }

    public function upsertAttendance(Request $request)
    {
        return $this->service->upsertAttendance($request->all(), auth()->user());
    }

    public function updateRate(Request $request, $uuid)
    {
        return $this->service->updateRate($request->all(), auth()->user(), $uuid);
    }

    public function upsertRsvp(Request $request, $uuid)
    {
        return $this->service->upsertRsvp($request->all(), auth()->user(), $uuid);
    }

    public function upsertRsvpYes(Request $request, $uuid)
    {
        return $this->service->upsertRsvpYes($request->all(), auth()->user(), $uuid);
    }

    public function upsertRsvpNo(Request $request, $uuid)
    {
        return $this->service->upsertRsvpNo($request->all(), auth()->user(), $uuid);
    }
}

app/View/Components/Modules/Admin/Orientation/Index/Detail/Filter.php
<?php

namespace App\View\Components\Modules\Admin\Orientation\Index\Detail;

use App\Constants\OrientationStatusConstant;
use App\Models\Campus;
use App\Models\Faculty;
use App\Models\Intake;
use App\Models\LevelStudy;
use App\Models\Locality;
use App\Models\Mobility;
use App\Models\OrientationType;
use App\Models\Programme;
use App\Models\School;
use Illuminate\Support\Str;
use Illuminate\View\Component;

class Filter extends Component
{
    public $id;

    /**
     * Create a new component instance.
     *
     * @return void
     */
    public function __construct($id)
    {
        $this->id = $id;
    }

    /**
     * Get the view / contents that represent the component.
     *
     * @return \Illuminate\Contracts\View\View|\Closure|string
     */
    public function render()
    {
        $options = $this->getOptions();
        return view('components.modules.admin.orientation.index.detail.filter', compact('options'));
    }

    protected function getOptions()
    {
        $status = array_filter(OrientationStatusConstant::getAvailableOptions('title'), function ($value) {
            return $value !== 'Draft';
        });
        return [
            'orientation_type' => OrientationType::all()->pluck('title', 'id'),
            'faculty' => Faculty::orderBy('name')->get()->pluck('name', 'id'),
            'status' => $status,
            'school' => School::orderBy('name')->get()->pluck('name', 'id'),
            'programme' => Programme::orderBy('name')->get()->pluck('name', 'id'),
            'level_study' => LevelStudy::orderBy('name')->get()->pluck('name', 'id'),
            'intake' => Intake::orderBy('name', 'desc')->get()->pluck('name', 'id'),
            'campus' => Campus::orderBy('name')->get()->pluck('name', 'id'),
            'mobility' => Mobility::orderBy('name')->get()->map(function ($mobility) {
                $mobility->name = Str::title($mobility->name);
                return $mobility;
            })->pluck('name', 'id'),
            'locality' => Locality::orderBy('name')->get()->pluck('name', 'id'),
        ];
    }
}

app/View/Components/Modules/Orientation/Index/Calendar/Filter.php
<?php

namespace App\View\Components\Modules\Orientation\Index\Calendar;

use App\Models\OrientationType;
use Illuminate\View\Component;

class Filter extends Component
{
    public $id;

    /**
     * Create a new component instance.
     *
     * @return void
     */
    public function __construct($id)
    {
        $this->id = $id;
    }

    /**
     * Get the view / contents that represent the component.
     *
     * @return \Illuminate\Contracts\View\View|\Closure|string
     */
    public function render()
    {
        $options = $this->getOptions();
        return view('components.modules.orientation.index.calendar.filter', compact('options'));
    }

    protected function getOptions()
    {
        return [
            'orientation_type' => OrientationType::all()->pluck('title', 'id'),
        ];
    }
}

resources/views/admin/orientation/create.blade.php
<x-layouts.app :title="$title" toolbarClass="py-3 py-lg-6 cover"
    toolbarStyle="background-image: url('{{ randomBackgroundImage() }}');">
    <x-slot name="toolbar">
        <x-share.breadcrumb :title="$title" :links="[
            [
                'url' => route('admin.orientations.index'),
                'text' => __('description.title.orientation', ['x' => 'Timeable']),
            ],
        ]" />
    </x-slot>
    <div id="kt_app_content_container" class="app-container container-xxl">
        @include('admin.orientation.create.stepper')
    </div>
</x-layouts.app>

resources/views/admin/orientation/index.blade.php
<x-layouts.app :title="$title" toolbarClass="py-3 py-lg-6 cover"
    toolbarStyle="background-image: url('{{ randomBackgroundImage() }}');">
    <x-slot name="toolbar">
        <x-share.breadcrumb :title="$title" />
    </x-slot>
    <ul class="nav nav-pills nav-pills-custom d-flex flex-center mb-3">
        <li class="nav-item me-3 me-lg-6 mb-3">
            <a class="nav-link btn btn-outline btn-flex btn-color-muted btn-active-color-primary flex-column w-150px h-85px active overflow-hidden pt-5 pb-2"
                id="tab_link_1" data-bs-toggle="pill" href="#tab_1">
                <img class="w-35px mb-1" src="{{ url('media/icons/taylors/detail.png') }}">
                <span class="nav-text fw-bold fs-6 lh-1 text-gray-800">Details</span>
                <span class="bullet-custom position-absolute w-100 h-4px bg-red bottom-0"></span>
            </a>
        </li>
        <li class="nav-item me-3 me-lg-6 mb-3">
            <a class="nav-link btn btn-outline btn-flex btn-color-muted btn-active-color-primary flex-column w-150px h-85px overflow-hidden pt-5 pb-2"
                id="tab_link_2" data-bs-toggle="pill" href="#tab_2"
                onclick="fullcalendars['orientationCalendar'].updateSize()">
                <img class="w-35px mb-1" src="{{ url('media/icons/taylors/calendar.png') }}">
                <span class="nav-text fw-bold fs-6 lh-1 text-gray-800">Calendar</span>
                <span class="bullet-custom position-absolute w-100 h-4px bg-red bottom-0"></span>
            </a>
        </li>
    </ul>
    <div id="kt_app_content_container" class="app-container container-xxl">
        <div class="tab-content">
            <div class="tab-pane fade show active" id="tab_1">
                @include('admin.orientation.index.tab-detail')
            </div>
            <div class="tab-pane fade" id="tab_2">
                @include('admin.orientation.index.tab-calendar')
            </div>
        </div>
    </div>
</x-layouts.app>

resources/views/admin/orientation/index2.blade.php
<x-layouts.app :title="$title" toolbarClass="py-3 py-lg-6 cover"
    toolbarStyle="background-image: url('{{ randomBackgroundImage() }}');">
    <x-slot name="toolbar">
        <div id="kt_app_toolbar_container" class="app-container container-xxl d-flex flex-stack">
            <div class="page-title d-flex flex-column justify-content-center flex-wrap me-3">
                <h1 class="page-heading d-flex text-white fw-bold fs-3 flex-column justify-content-center my-0">
                    {{ $title }}</h1>
                <ul class="breadcrumb breadcrumb-separatorless fw-semibold fs-7 my-0 pt-1">
                    <li class="breadcrumb-item text-muted">
                        <a href="{{ url('/') }}" class="text-white text-hover-white">Home</a>
                    </li>
                    <li class="breadcrumb-item">
                        <span class="bullet bg-gray-400 w-5px h-2px"></span>
                    </li>
                    <li class="breadcrumb-item text-muted">
                        <a href="{{ route('dashboard.index') }}" class="text-white text-hover-white">Dashboard</a>
                    </li>
                    <li class="breadcrumb-item">
                        <span class="bullet bg-gray-400 w-5px h-2px"></span>
                    </li>
                    <li class="breadcrumb-item text-muted">
                        <span class="text-primary">{{ $title }}</span>
                    </li>
                </ul>
            </div>
        </div>
    </x-slot>
    <div id="kt_app_content_container" class="app-container container-xxl">
        <div class="card">
            <div class="card-body">
                <div class="d-flex flex-stack flex-wrap mb-5">
                    <x-datatables.search id="viewOrientationDt" placeholder="Search Orientation (Details)" />
                    <div class="d-flex justify-content-end">
                        <x-modules.admin.orientation.index.detail.filter id="viewOrientationDt" />
                        <div>
                            <x-datatables.export id="viewOrientationDt" />
                        </div>
                    </div>
                </div>
                <div id="viewOrientationDtScrollbarX" class="table-scrollbar-x" data-parentEl="#viewOrientationDt_wrapper .table-responsive">
                    <div class="scrollbar-x">&nbsp;</div>
                </div>
                {!! $viewOrientationDt->html()->table() !!}
                <div id="viewOrientationDtScrollbarXEnd"></div>
                @push('script')
                    dtx.initOption('viewOrientationDt');
                    {!! $viewOrientationDt->generateMinifyScripts() !!}
                @endpush
            </div>
        </div>
        
    </div>
</x-layouts.app>

resources/views/admin/orientation/show.blade.php
<x-layouts.app :title="$title" toolbarClass="py-3 py-lg-6 cover"
    toolbarStyle="background-image: url('{{ randomBackgroundImage() }}');">
    <x-slot name="toolbar">
        <x-share.breadcrumb :title="$title" :links="[
            [
                'url' => route('admin.orientations.index'),
                'text' => __('description.title.orientation', ['x' => 'Timeable']),
            ],
        ]" />
    </x-slot>
    <div id="kt_app_content_container" class="app-container container-xxl">
        @include('admin.orientation-approval.edit.summary')
        @if ($orientation->is_status_approved)
            <div class="card">
                <ul
                    class="card-header nav nav-tabs nav-line-tabs min-h-auto text-nowrap mt-3 flex-nowrap overflow-y-auto">
                    <li class="nav-item card-title mb-0">
                        <a class="nav-link active text-black" data-bs-toggle="tab" href="#details">
                            Orientation Activity Details
                        </a>
                    </li>
                    @if ($orientation->is_rsvp)
                        <li class="nav-item card-title mb-0">
                            <a class="nav-link text-black" data-bs-toggle="tab" href="#rsvp-tab">
                                RSVP
                            </a>
                        </li>
                    @endif
                    @if ($orientation->is_type_activity)
                        <li class="nav-item card-title mb-0">
                            <a class="nav-link text-black" data-bs-toggle="tab" href="#attendance-tab">
                                Attendance
                            </a>
                        </li>
                    @endif
                    <li class="nav-item card-title mb-0">
                        <a class="nav-link text-black" data-bs-toggle="tab" href="#recording-tab">
                            Recording & Attachment
                        </a>
                    </li>
                    <li class="nav-item card-title mb-0">
                        <a class="nav-link text-black" data-bs-toggle="tab" href="#log-tab">
                            Log History
                        </a>
                    </li>
                </ul>
                <div class="tab-content">
                    <div class="tab-pane fade show active pt-3" id="details" role="tabpanel"
                        style="background-color: var(--kt-app-bg-color);">
                        @include('admin.orientation.show.stepper')
                    </div>
                    @if ($orientation->is_rsvp)
                        @include('admin.orientation.show.tab-pane-rsvp')
                    @endif
                    @if ($orientation->is_type_activity)
                        @include('admin.orientation.show.tab-pane-attendance')
                    @endif
                    @include('admin.orientation.show.tab-pane-recording')
                    <div class="tab-pane fade" id="log-tab" role="tabpanel">
                        <div class="card-body">
                            <div class="table-responsive">
                                {!! $actionDt->html()->table() !!}
                                @push('script')
                                    {!! $actionDt->generateMinifyScripts() !!}
                                @endpush
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        @else
            @include('admin.orientation.show.stepper')
        @endif
    </div>
</x-layouts.app>